L16. Sliding Window Maximum | Stack and Queue Playlist

Поділитися
Вставка
  • Опубліковано 22 гру 2024

КОМЕНТАРІ • 54

  • @kshitijsingh879
    @kshitijsingh879 4 місяці тому +20

    We use a deque to maintain the k elements and find maximums easily.
    When we find an element in the array greater than the top element, we remove lower elements from the deque since the max is changing.
    We continue this until we find a bigger element in the deque than the current element in the array.
    When i > k - 1, we add the answer because our window is at least k elements wide.
    We also maintain the correct size by checking i - k

    • @akashadak4160
      @akashadak4160 3 місяці тому +1

      nice summarisation

    • @Gokul-gkl
      @Gokul-gkl 17 днів тому

      yes but in the worst case it gives O(n*n)(~brute force) , which should be avoided right
      that's why we are using the extra space

  • @sohaildarwajkar9979
    @sohaildarwajkar9979 3 місяці тому +10

    I dont comment usually but i would suggest to look the same que from his old playlist. He has explained better there.

    • @arunm619
      @arunm619 День тому

      Only one person can do better than him. That's himself.

  • @SurajKumar-ku1lg
    @SurajKumar-ku1lg 4 місяці тому +4

    best video on sliding window maximum problem

  • @studystuff51
    @studystuff51 4 місяці тому +9

    Bhaiya, after seeing you solve the example, without even seeing you write the pseudo code I was able to solve the question by myself. Thing is, I am not able to think of the approach till you solved the example. I don't know how to come up with the approach myself.

  • @AtharvaRao0104
    @AtharvaRao0104 4 місяці тому +15

    some unimportant info:
    deque is pronounced as “deck.” for eg: deck of cards .. it is short form of double-ended-queue .. anyway concept is important not names

    • @hwrsh
      @hwrsh Місяць тому +1

      wow

  • @himalayadebbarma-we4pt
    @himalayadebbarma-we4pt 4 місяці тому +2

    Thanks Striver

  • @tazanteflight8670
    @tazanteflight8670 3 місяці тому +2

    thanks for showing a unsorted data version. Data is never sorted!

  • @aashijain7578
    @aashijain7578 Місяць тому

    can we use a deque of size k
    1. if deque empty: insert element -> update maxi
    2. while size of deque < k:
    add element and update maxi
    3. if size of deque == k:
    update our ans array with maxi and remove the first element from the deque.

  • @barathkumar3583
    @barathkumar3583 3 місяці тому +1

    His previous video on same topic explains same concept very detaily

  • @karthi2174
    @karthi2174 17 днів тому

    Hello everyone, my placements are starting in March 2025. I have started learning DSA using the TakeUforward SDE sheet and have completed the first 10 problems. However, I was able to understand only 3 of them, and I am struggling to build logic on my own. I am unsure if I am on the right track or where to start. Could you please give me some advice on how to approach solving problems independently and where I should begin? I have programming knowledge but need guidance. I am not aiming to join a big MNC company, but I want to prepare effectively.

  • @AamilAli2003
    @AamilAli2003 Місяць тому +2

    Who's here after 50/51 testcases passed 😢

  • @CP_Danger
    @CP_Danger 17 днів тому

    i tried implementing a max queue but i dont know where I am failing , even chatgpt is not suggesting any good corrections.
    void push(queue& q,int& Max,int x){
    if(x>Max) {
    q.push((x-Max)+x);
    Max = x;
    }
    else q.push(x);
    }
    void pop(queue& q,int& Max){
    if(q.front() >= (Max + Max - q.front())){
    Max = Max - (q.front()-Max);
    q.pop();
    }
    else q.pop();
    }
    int front(queue& q,int& Max){
    if(q.front()>Max){
    return Max;
    }
    else return q.front();
    }
    vector maxSlidingWindow(vector& nums, int k) {
    int n = nums.size();
    vector res(n-k+1);
    queue q;
    int maxq = -100000;
    for(int i = 0;i

  • @TOI-700
    @TOI-700 2 місяці тому

    GOT YOU BOTHER RAJ

  • @oyeshxrme
    @oyeshxrme 2 місяці тому

    thanks bhaiya

  • @sanketatmaram
    @sanketatmaram 3 місяці тому

    understood!

  • @tnfdigen1350
    @tnfdigen1350 5 місяців тому

    Bhya ❤👍👍

  • @KartikeyTT
    @KartikeyTT 5 місяців тому

    tysm sir

  • @DeadPoolx1712
    @DeadPoolx1712 2 місяці тому

    UNDERSTOOD;

  • @sanchitdeepsingh9663
    @sanchitdeepsingh9663 5 місяців тому

    thanks sir

  • @TOI-700
    @TOI-700 2 місяці тому

    SANK YOU, THANK YOU

  • @zaffarzeshan1308
    @zaffarzeshan1308 4 місяці тому +41

    striver not teaching well as compare with old video only expression giving

    • @rishabhkansal5811
      @rishabhkansal5811 4 місяці тому +3

      Yes, I also felt the same. He is not teaching in this playlist like earlier all playlist

    • @Ayush37262
      @Ayush37262 4 місяці тому +6

      I agreed. This Stack and Queue playlist is bad tbh.
      Bhai ek toh dono data structures ko ek hi playlist mein kyu add kar diya 🤦‍♂️

    • @crazymemes4080
      @crazymemes4080 4 місяці тому +1

      Felt the same, i am going back and checking his old video:)

    • @Ayush37262
      @Ayush37262 4 місяці тому +3

      Bhai course launch karne ke baad mindset pura badal jaata hai...

    • @vinamrasangal8436
      @vinamrasangal8436 3 місяці тому

      @@Ayush37262 right

  • @shashankvashishtha4454
    @shashankvashishtha4454 5 місяців тому

    understood

  • @chanduhl7060
    @chanduhl7060 Місяць тому

    From where can I understand it 😂

  • @subhasrisb11tha28
    @subhasrisb11tha28 2 місяці тому

    😄

  • @TOI-700
    @TOI-700 2 місяці тому

    understooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooood !?!?!! IDK

  • @codmobile1866
    @codmobile1866 5 місяців тому

    first

  • @WebSurfingIsMyPastime
    @WebSurfingIsMyPastime 5 місяців тому +4

    Good post, slow down the releases and you’ll get more views. Nobody can handle viewing and reviewing and learning 3-4 leetcode problems a day. Maybe a speed of one every few days is better

    • @brainmosquito7
      @brainmosquito7 5 місяців тому +26

      apni suggestion apne paas rkh

    • @sarveshkulkarni6287
      @sarveshkulkarni6287 5 місяців тому +4

      That's personal issue, he's already working in a company so as per his valuable time he uploads video's just for us,insteading of asking him for slow releases you yourself can manage your time as you are in need not him.

    • @WebSurfingIsMyPastime
      @WebSurfingIsMyPastime 5 місяців тому +2

      @@sarveshkulkarni6287 Of course I can manage my time. My suggestion is not for me, but for his channel. Most people will skip multiple videos if the speed of delivery is too fast. So (for his channel and engagement) I made the suggestion that he should slow the release, that way he will get more clicks.
      Monetizing youtube videos is not as simple as one would think. You only make money on the views during the first few days of the videos release. If he releases multiple videos and the majority of the engagement/views are not immediate, he will not get much money from releasing this content.

    • @anishsood3084
      @anishsood3084 5 місяців тому

      @@WebSurfingIsMyPastime bro jisne padna vo channel search kr ke pad lega.

    • @gnanyadapa9666
      @gnanyadapa9666 4 місяці тому +1

      ​@@WebSurfingIsMyPastimeWhy are you considering that only first few days would account for the views? Think about the long run mate.

  • @piyushsinghdtu456
    @piyushsinghdtu456 3 місяці тому

    understood